﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10.6
@EndOfDesignText@
Sub Class_Globals
	
	'Dichiarazioni Public
	Public SQL1 As SQL				'Oggetto per accedere al DB SQL (tipo oggetto Database)
	Public lstRowID As List			'List contenente gli ID (campo rowID) del database
	Public CurrentIndex = -1 As Int	'indice corrente della List contenente gli IDRow
	
	'Dichiarazioni View
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private bxtTable As B4XTable ' è una customview
	Private ToastMessage As BCToast
	Private lblSelectedItem As B4XView
End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'Root.LoadLayout("layDB_Table")
	Root.LoadLayout("layDB_Table")
	
	#If B4J
	xui.SetDataFolder("B4XPages_SQLiteLight2")
	#End If
	
	InitTable 'imposta la B4XTable (crea le colonne)
	
	AperturaDataBase
	
End Sub

Private Sub B4XPage_Appear
	MostraTable 'Mostro i record nella CustomView
End Sub

Private Sub InitTable
	'Inzializza la CustomView bxtTable aggiungendo 3 colonne
	'Non ha usato CustomListView perché non ha lo scorrimento orizzontale.
	'Con più colonne da visualizzare, è un problema senza questa caratteristica.
	'B4XTable invece lo ha, ma non ha lo scorrimento verticale, è basato sulla pagina.
	bxtTable.AddColumn("First name", bxtTable.COLUMN_TYPE_TEXT)
	bxtTable.AddColumn("Last name", bxtTable.COLUMN_TYPE_TEXT)
	bxtTable.AddColumn("City", bxtTable.COLUMN_TYPE_TEXT)
End Sub

Sub AperturaDataBase
	
	Log(modApp.NomeDB)
	If File.Exists(xui.DefaultFolder, modApp.NomeDB) = False Then
		
		Log("il db esiste in DirAssets?: " & File.Exists(File.DirAssets,modApp.NomeDB))
		
		File.Copy(File.DirAssets, modApp.NomeDB, xui.DefaultFolder, modApp.NomeDB)
	End If
	SQL1.Initialize(xui.DefaultFolder, modApp.NomeDB, True)
	
	#If B4J
	SQL1.InitializeSQLite(xui.DefaultFolder, modApp.NomeDB, True)
	#End If
	ToastMessage.Initialize(Root)
End Sub


'Shows the database in a table in a B4XTable
Public Sub MostraTable
	Private Query As String

	ReadDataBaseRowIDs
	
	Query = "SELECT FirstName, LastName, City FROM persons"
	
	Dim Data As List
	Data.Initialize
	Dim rs As ResultSet = SQL1.ExecQuery(Query)
	Do While rs.NextRow
		Dim row(3) As Object
		row(0) = rs.GetString("FirstName")
		row(1) = rs.GetString("LastName")
		row(2) = rs.GetString("City")
		Data.Add(row)
	Loop
	rs.Close
	
	'Questa istruzione provvede a trasferire i dati nella bxtTable
	bxtTable.SetData(Data)
	
	AggiornaLabel
	
End Sub

Private Sub B4XPage_CloseRequest As ResumableSub
	Dim sf As Object = xui.Msgbox2Async("Do you want to quit ?", "Quit", "Yes", "Cancel", "No", Null)
	Wait For (sf) Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		Return True
	End If
	Return False
End Sub

'Legge il campo rowID in lstRowID
Private Sub ReadDataBaseRowIDs
	
	'Riempie una List pUBLIC chiamata lstRowID, con tutti gli ID dei record della tabella
	Dim ResultSet1 As ResultSet 'E' come un cursore, come un recordset, ma piu avanzato
	
	ResultSet1 = SQL1.ExecQuery("SELECT rowID FROM persons")
	
	'Viene letto solo il campo rowID e messo nella IDList
	lstRowID.Initialize						'initialize the ID list
	
	'Finche Ci sono record
	Do While ResultSet1.NextRow
		lstRowID.Add(ResultSet1.GetInt2(0))	'aggiunge l'ID alla lista lstRowID
	Loop
	
	'Se ci sono record
	If lstRowID.Size > 0 Then
		If CurrentIndex = -1 Or CurrentIndex > lstRowID.Size - 1 Then
			CurrentIndex = 0			'set the current index to 0
		End If
	Else
		CurrentIndex = -1			'imposta il corrente indice to -1, non ci sono record selezionati
		ToastMessage.Show("No items found")
	End If
	ResultSet1.Close							'chiude il ResultSet, non dobbiamo fare piu nulla
End Sub


Public Sub AggiornaLabel
	
	'Se CurrentIndex ha un valore (un numero di riga)
	If CurrentIndex > -1 Then
		
		'creo una query per ricavare il record relativo
		Private Query As String
		Private ResultSet1 As ResultSet ' resultset temporaneo per prendere il record
	
		Query = "SELECT FirstName, LastName FROM persons WHERE rowid = " & lstRowID.Get(CurrentIndex)
		ResultSet1 = SQL1.ExecQuery(Query)
		ResultSet1.NextRow
		
		'Valorizzo la label apposita
		lblSelectedItem.Text = ResultSet1.GetString("FirstName") & " " & ResultSet1.GetString("LastName")
		Log(ResultSet1.GetString("FirstName") & " " & ResultSet1.GetString("LastName"))
		'Chiudo il resultSet
		ResultSet1.Close
	Else
		lblSelectedItem.Text = ""
	End If
End Sub

Private Sub bxtTable_CellClicked (ColumnId As String, RowId As Long)
	
	'Se clicco su una cella , memorizzo su che riga sono
	CurrentIndex = RowId - 1
	'Aggiorno la label apposita
	AggiornaLabel
End Sub

